## btor2tools 1.0.2~git20250507.fb69ee3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(btor2tools)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include(GNUInstallDirs)

#-----------------------------------------------------------------------------#

option(ASAN              "Compile with ASAN support" OFF)
option(BUILD_BTOR2AIGER  "Build btor2aiger binary" OFF)
option(BUILD_TOOLS       "Build btorsim, catbtor, btorsplit binaries" ON)
option(CHECK             "Enable assertions for optimized builds" OFF)
option(BUILD_SHARED_LIBS "Build as shared library" ON)

#-----------------------------------------------------------------------------#

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)

macro(add_c_flag flag)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}")
  message(STATUS "Configuring with C flag '${flag}'")
endmacro()

macro(add_cxx_flag flag)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
  message(STATUS "Configuring with CXX flag '${flag}'")
endmacro()

macro(add_c_cxx_flag flag)
  add_c_flag(${flag})
  add_cxx_flag(${flag})
endmacro()

macro(add_check_c_flag flag)
  string(REGEX REPLACE "[-=]" "_" flagname ${flag})
  check_c_compiler_flag("${flag}" HAVE_FLAG${flagname})
  if(HAVE_FLAG${flagname})
    add_c_flag(${flag})
  endif()
endmacro()

macro(add_check_cxx_flag flag)
  string(REGEX REPLACE "[-=]" "_" flagname ${flag})
  check_cxx_compiler_flag("${flag}" HAVE_FLAG${flagname})
  if(HAVE_FLAG${flagname})
    add_cxx_flag(${flag})
  endif()
endmacro()

macro(add_check_c_cxx_flag flag)
  add_check_c_flag(${flag})
  add_check_cxx_flag(${flag})
endmacro()

macro(add_required_cxx_flag flag)
  string(REGEX REPLACE "[-=]" "_" flagnamename ${flag})
  check_cxx_compiler_flag("${flag}" HAVE_FLAG${flagname})
  if (NOT HAVE_FLAG${flagname})
    message(FATAL_ERROR "Required compiler flag ${flag} not supported")
  endif()
  add_cxx_flag(${flag})
endmacro()

macro(add_required_c_flag flag)
  string(REGEX REPLACE "[-=]" "_" flagname ${flag})
  check_c_compiler_flag("${flag}" HAVE_FLAG${flagname})
  if (NOT HAVE_FLAG${flagname})
    message(FATAL_ERROR "Required compiler flag ${flag} not supported")
  endif()
  add_c_flag(${flag})
endmacro()

macro(add_required_c_cxx_flag flag)
  add_required_c_flag(${flag})
  add_required_cxx_flag(${flag})
endmacro()

#-----------------------------------------------------------------------------#

add_check_c_cxx_flag("-W")
add_check_c_cxx_flag("-Wall")
add_check_c_cxx_flag("-Wextra")
add_check_c_cxx_flag("-Wredundant-decls")

add_check_c_flag("-std=gnu99")
add_required_cxx_flag("-std=gnu++11")

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_check_c_cxx_flag("-g3")
  add_check_c_cxx_flag("-ggdb")
else()
  add_check_c_cxx_flag("-O3")
  if(NOT CHECK)
    add_check_c_cxx_flag("-DNDEBUG")
  endif()
endif()

if(ASAN)
  # -fsanitize=address requires CMAKE_REQUIRED_FLAGS to be explicitely set,
  # otherwise the -fsanitize=address check will fail while linking.
  set(CMAKE_REQUIRED_FLAGS -fsanitize=address)
  add_required_c_cxx_flag("-fsanitize=address")
  unset(CMAKE_REQUIRED_FLAGS)
  add_check_c_cxx_flag("-fno-omit-frame-pointer")
  add_required_c_cxx_flag("-fsanitize-recover=address")
  set(BUILD_SHARED_LIBS ON)
endif()

if(BUILD_BTOR2AIGER)
  if(NOT EXISTS "${CMAKE_SOURCE_DIR}/deps/aiger/aiger.c")
    message(FATAL_ERROR
            "Could not find AIGER sources. Execute script setup-aiger.sh.")
  endif()
  list(APPEND CMAKE_PREFIX_PATH "${PROJECT_SOURCE_DIR}/deps/install")
  find_package(Boolector)
endif()

add_subdirectory(src)

=== src/CMakeLists.txt ===
add_library(btor2parser
  btor2parser/btor2parser.c
)
target_include_directories(btor2parser PRIVATE .)
set_target_properties(btor2parser PROPERTIES PUBLIC_HEADER btor2parser/btor2parser.h)
install(
  TARGETS btor2parser
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

if (BUILD_TOOLS)
  add_executable(btorsim
    btorsim/btorsimam.cpp
    btorsim/btorsimstate.cpp
    btorsim/btorsimvcd.cpp
    btorsim/btorsimhelpers.cpp
    btorsim/btorsim.cpp
    btorsim/btorsimbv.c
    btorsim/btorsimrng.c
  )
  target_include_directories(btorsim PRIVATE .)
  target_link_libraries(btorsim btor2parser)
  target_compile_options(btorsim PRIVATE -Wall -Wfatal-errors)
  install(TARGETS btorsim DESTINATION ${CMAKE_INSTALL_BINDIR})

  add_executable(catbtor catbtor.c)
  target_link_libraries(catbtor btor2parser)
  install(TARGETS catbtor DESTINATION ${CMAKE_INSTALL_BINDIR})

  add_executable(btorsplit btorsplit.cpp)
  install(TARGETS btorsplit DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if(BUILD_BTOR2AIGER)
  add_executable(btor2aiger
    btor2aiger.cpp
    ${CMAKE_SOURCE_DIR}/deps/aiger/aiger.c
  )
  target_include_directories(btor2aiger PRIVATE . ${CMAKE_SOURCE_DIR}/deps/aiger)
  target_compile_options(btor2aiger PRIVATE -std=c++11 -Wall -g -g3 -ggdb)
  target_link_libraries(btor2aiger btor2parser Boolector::boolector)
  install(TARGETS btor2aiger DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== debian/changelog ===
btor2tools (1.0.2~git20250507.fb69ee3-2) unstable; urgency=medium

  * Refine d/copyright after Gateway to new hints
  * Standards-Version: 4.7.3 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)

 -- Andreas Tille <tille@debian.org>  Fri, 30 Jan 2026 15:05:45 +0100

btor2tools (1.0.2~git20250507.fb69ee3-1) unstable; urgency=medium

  * Initial release (Closes: #1111868)

 -- Andreas Tille <tille@debian.org>  Sat, 23 Aug 2025 06:54:26 +0200

=== debian/control ===
Source: btor2tools
Section: science
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               d-shlibs
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/science-team/btor2tools
Vcs-Git: https://salsa.debian.org/science-team/btor2tools.git
Homepage: https://github.com/boolector/btor2tools

Package: btor2tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libbtor2tools0
Description: generic parser and tools for the BTOR2 format
 BTOR2 is a word-level model checking format for capturing models of
 hardware and potentially software in a bit-precise manner. This simple,
 line-based and easy to parse format can be seen as a sorted extension of
 the word-level format BTOR. It uses design principles from the bit-level
 format AIGER and follows semantics of the SMT-LIB logics of bit-vectors
 with arrays. This intermediate format can be used in various
 verification flows and is perfectly suited to establish a word-level
 model checking competition.

Package: libbtor2parser0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: library for generic parser and tools for the BTOR2 format
 BTOR2 is a word-level model checking format for capturing models of
 hardware and potentially software in a bit-precise manner. This simple,
 line-based and easy to parse format can be seen as a sorted extension of
 the word-level format BTOR. It uses design principles from the bit-level
 format AIGER and follows semantics of the SMT-LIB logics of bit-vectors
 with arrays. This intermediate format can be used in various
 verification flows and is perfectly suited to establish a word-level
 model checking competition.
 .
 This package provides the shared library.

Package: libbtor2parser-dev
Architecture: any
Section: libdevel
Depends: libbtor2parser0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: development lib for generic parser and tools for the BTOR2 format
 BTOR2 is a word-level model checking format for capturing models of
 hardware and potentially software in a bit-precise manner. This simple,
 line-based and easy to parse format can be seen as a sorted extension of
 the word-level format BTOR. It uses design principles from the bit-level
 format AIGER and follows semantics of the SMT-LIB logics of bit-vectors
 with arrays. This intermediate format can be used in various
 verification flows and is perfectly suited to establish a word-level
 model checking competition.
 .
 This package provides the header file and the static library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --movedev debian/tmp/usr/include/* usr/include \
	            debian/tmp/usr/lib/*/*.so

=== debian/watch ===
version=4

# using '~' to be able to stick to version 1.0.2 which might be a previous tag then latest
opts="mode=git,pretty=1.0.2~git%cd.%h" \
    https://github.com/hwmcc/btor2tools.git HEAD

# Asked for tags
#  https://github.com/hwmcc/btor2tools/issues/32
